###################################################
### chunk number 1: 
###################################################
library(gRbase)


###################################################
### chunk number 2: 
###################################################
## 1-dimensional array
##
x1 <- 1:8
dim(x1) <- 8
x1
is.array(x1)
is.matrix(x1)

## 2-dimensional array (matrix)
##
x2 <- 1:8
dim(x2) <- c(2,4)
x2
is.array(x2)
is.matrix(x2)

## 3-dimensional array
##
x3 <- array(1:8, dim=c(2,2,2))
x3
is.array(x3)
is.matrix(x3)


###################################################
### chunk number 3: 
###################################################
flevels <- c(2,3,2,4)


###################################################
### chunk number 4: 
###################################################
cell2entry(c(1,1,1,1), flevels) 
entry2cell(1, flevels)
cell2entry(c(2,1,2,1), flevels) 
entry2cell(8, flevels)


###################################################
### chunk number 5:  eval=FALSE
###################################################
## cell2entry2(c(2,1,2,1), flevels) 
## cell2entryR(c(2,1,2,1), flevels) 


###################################################
### chunk number 6:  eval=FALSE
###################################################
## system.time(for (kk in 1:20000){cell2entry(c(2,1,2,1),flevels)})
## system.time(for (kk in 1:20000){cell2entry2(c(2,1,2,1),flevels)})
## system.time(for (kk in 1:20000){cell2entryR(c(2,1,2,1),flevels)})
## system.time(for (kk in 1:20000){entry2cellR(6,flevels)})


###################################################
### chunk number 7: 
###################################################
nextCell(c(1,1,2,1), flevels)
nextCell(c(2,3,2,4), flevels)


###################################################
### chunk number 8: 
###################################################
nextCellMarg(c(1,3,2,1),    margset=c(2,3), flevels)
nextCellMarg(c(2,3,2,1),    margset=c(2,3), flevels)


###################################################
### chunk number 9: 
###################################################
margcell2entry(margcell=c(1,2), margset=c(2,3), flevels)
margcell2entry(margcell=c(2,2), margset=c(1,2), flevels)


###################################################
### chunk number 10: 
###################################################
ff <- factgrid(flevels)
head(ff)
tail(ff)

ff <- factgrid(flevels, margcell=c(1,2), margset=c(2,3))
ff


