###################################################
### chunk number 1: 
###################################################
library(gRbase)
library(Rgraphviz)
#lprint <- function(x) cat(paste(x),"\n")
#print.character <- function(x) cat(paste(x, collapse=' '),"\n")
#print.list <- function(a) {names(a)<-NULL; 
#  lapply(lapply(a,paste, collapse=' '),cat, "\n")
#}


###################################################
### chunk number 2: 
###################################################
ug11 <- ug(~a*b*c, ~c*d, ~d*e, ~e*a, ~f*g)
ug12 <- ug(~a*b*c + c*d + d*e + a*e + f*g)
ug13 <- ug(c("a","b","c"),c("c","d"),c("d","e"),c("a","e"),c("f","g"))
ug13


###################################################
### chunk number 3: 
###################################################
ug11m <- ugMAT(~a*b*c, ~c*d, ~d*e, ~e*a, ~f*g)
ug12m <- ugMAT(~a*b*c + c*d + d*e + a*e + f*g)
ug13m <- ugMAT(c("a","b","c"),c("c","d"),c("d","e"),c("a","e"),c("f","g"))
ug13m


###################################################
### chunk number 4: 
###################################################
dag11 <- dag(~a, ~b*a,  ~c*a*b, ~d*c*e, ~e*a, ~g*f)
dag12 <- dag("a", c("b","a"), c("c","a","b"), c("d","c","e"), 
             c("e","a"),c("g","f"))
dag12


###################################################
### chunk number 5: 
###################################################
dag11m <- dagMAT(~a, ~b*a,  ~c*a*b, ~d*c*e, ~e*a, ~g*f)
dag12m <- dagMAT("a", c("b","a"), c("c","a","b"), c("d","c","e"), 
                 c("e","a"),c("g","f"))
dag12m


###################################################
### chunk number 6: 
###################################################
moralize(dag11)


###################################################
### chunk number 7: 
###################################################
mcs(ug11)


###################################################
### chunk number 8: 
###################################################
tug1<-triangulate(ug11)


###################################################
### chunk number 9: 
###################################################
r <- rip(tug1)
r


###################################################
### chunk number 10: 
###################################################
as(ug11, "matrix")
as(ug11m, "graphNEL")


###################################################
### chunk number 11: 
###################################################
as(dag11,"matrix")
as(dag11m, "graphNEL")


###################################################
### chunk number 12: 
###################################################
system.time({for (ii in 1:200) as(ug11, "matrix")})
system.time({for (ii in 1:200) as.adjMAT(ug11)})


###################################################
### chunk number 13: 
###################################################
system.time({for (ii in 1:200) maxClique(ug11)})
system.time({for (ii in 1:200) maxCliqueMAT(ug11m)})


###################################################
### chunk number 14: 
###################################################
V <- 1:100
M <- 1:10
## Sparse graph 
##
g1 <- randomGraph(V, M, 0.05)
length(edgeList(g1))
object.size(g1)
object.size(as.adjMAT(g1))

## More dense graph 
##
g1 <- randomGraph(V, M, 0.2)
length(edgeList(g1))
object.size(g1)
object.size(as.adjMAT(g1))

## Even more dense graph 
##
g1 <- randomGraph(V, M, 0.5)
length(edgeList(g1))
object.size(g1)
object.size(as.adjMAT(g1))


###################################################
### chunk number 15: 
###################################################
#rm(print.list)
options("width"=85)


